package refactorerl.ui.core.handlers;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.commands.IHandler;

import com.ericsson.otp.erlang.OtpErlangAtom;
import com.ericsson.otp.erlang.OtpErlangList;
import com.ericsson.otp.erlang.OtpErlangObject;
import com.ericsson.otp.erlang.OtpErlangTuple;

import refactorerl.ui.core.connection.ConnectionPool;
import refactorerl.ui.core.connection.IConnection;
import refactorerl.ui.core.connection.ReferlUI;

public class ClusteringHandler extends AbstractHandler implements IHandler{
	@Override
	public Object execute(ExecutionEvent event) throws ExecutionException {
		String algorithm  = event.getParameter("refactorerl.ui.extensions.clustering.algorithm");
		if (null == algorithm || "".equals(algorithm)) {
			return null;
		}
		
		String entityType = event.getParameter("refactorerl.ui.extensions.clustering.entityType");
		if (null == entityType || "".equals(algorithm)) {
			return null;
		}
		
		IConnection connection;
		connection = ConnectionPool.getInstance().getConnection();
		
		if (!connection.ping()) {
			connection.connect();
		}
		
		ReferlUI referlUI = connection.getReferlUI();
		
		referlUI.sendRequest(
				"transform",
				new OtpErlangAtom("clustering"),
				new OtpErlangList(
						new OtpErlangObject[] {
								new OtpErlangTuple(
										new OtpErlangObject[] {
												new OtpErlangAtom("ask_missing"),
												new OtpErlangAtom("true")
										}),
								new OtpErlangTuple(
										new OtpErlangObject[] {
												new OtpErlangAtom("algorithm"),
												new OtpErlangAtom(algorithm)
										}),
								new OtpErlangTuple(
										new OtpErlangObject[] {
												new OtpErlangAtom("entity"),
												new OtpErlangAtom(entityType)
										})
						})
				);
		
		return null;
	}
}
