module Paths_bufferserver (
    version,
    getBinDir, getLibDir, getDataDir, getLibexecDir,
    getDataFileName
  ) where

import Data.Version (Version(..))
import System.Environment (getEnv)

version :: Version
version = Version {versionBranch = [0,1], versionTags = []}

bindir, libdir, datadir, libexecdir :: FilePath

bindir     = "../../../bin"
libdir     = "/home/melinda/.cabal/lib/bufferserver-0.1/ghc-6.12.3"
datadir    = "/home/melinda/.cabal/share/bufferserver-0.1"
libexecdir = "/home/melinda/.cabal/libexec"

getBinDir, getLibDir, getDataDir, getLibexecDir :: IO FilePath
getBinDir = catch (getEnv "bufferserver_bindir") (\_ -> return bindir)
getLibDir = catch (getEnv "bufferserver_libdir") (\_ -> return libdir)
getDataDir = catch (getEnv "bufferserver_datadir") (\_ -> return datadir)
getLibexecDir = catch (getEnv "bufferserver_libexecdir") (\_ -> return libexecdir)

getDataFileName :: FilePath -> IO FilePath
getDataFileName name = do
  dir <- getDataDir
  return (dir ++ "/" ++ name)
