%%% -*- coding: latin-1 -*-

%%% The  contents of this  file are  subject to  the Erlang  Public License,
%%% Version  1.1, (the  "License");  you may  not  use this  file except  in
%%% compliance  with the License.  You should  have received  a copy  of the
%%% Erlang  Public License  along  with this  software.  If not,  it can  be
%%% retrieved at http://plc.inf.elte.hu/erlang/
%%%
%%% Software  distributed under  the License  is distributed  on an  "AS IS"
%%% basis, WITHOUT  WARRANTY OF ANY  KIND, either expressed or  implied. See
%%% the License  for the specific language governing  rights and limitations
%%% under the License.
%%%
%%% The Original Code is RefactorErl.
%%%
%%% The Initial Developer of the  Original Code is Etvs Lornd University.
%%% Portions created  by Etvs  Lornd University are  Copyright 2009,
%%% Etvs Lornd University. All Rights Reserved.

%%% @author Viktoria Fordos <v@fviktoria.hu>
%% -*- mode: nitrogen -*-
-module (ajax_handler).
-compile(export_all).
-include_lib("nitrogen/include/wf.hrl").
-include_lib("kernel/include/file.hrl").
-vsn("$Rev: 6528 $ ").


main() ->
	case wf:role(auth_users) of
        true ->
			#template { file=nitrogen_helper:get_nitrogen_site_dir()++
								 "/templates/ajax_handler.html" };
        false ->
    		wf:header("WWW-Authenticate", "HTTP/1.1 403 Forbidden"),
    		wf:status_code(403),
    		"<strong>Access Denied!</strong>"
    end.

get_content()->
	case wf:q(dir) of
		undefined->"";
		"__multi_dirs__"->
			case wf:q(mod) of
				undefined -> "";
				"db"->TopLevelDirs=
						  nitrogen_helper:get_file_browser_loaded_files_root(),
					  LiList=get_li_list("",TopLevelDirs),
					  "<ul class='jqueryFileTree' style='display: none;'>"++
						  LiList++
						  "</ul>";
				"server"->TopLevelDirs=
							  nitrogen_helper:get_file_browser_server_root(),
						  LiList=get_li_list("",TopLevelDirs),
						  "<ul class='jqueryFileTree' style='display: none;'>"++
							  LiList++
							  "</ul>";
				_ -> ""
			end;
		RootDir->case wf:q(mod) of
					 "db"->LiList=
							get_li_list("",
										nitrogen_helper:get_loaded_files_list(
										  RootDir)),
						   "<ul class='jqueryFileTree' style='display: none;'>"++
							   LiList++
							   "</ul>";
					 _ ->case file:list_dir(RootDir) of
							 {ok,FileNames}->
								 LiList=get_li_list(RootDir,FileNames),
								 "<ul class='jqueryFileTree' style='display: none;'>"++
									 LiList++
									 "</ul>";
							{error, _}->""
				 		 end
				 end
	end.

receive_ajax()->
	%if the request was different from 'selected_file', do nothing.
	case wf:q(dir) of
		undefined ->wf:session(selected_file,wf:q(selected_file)),
					"";
		_ -> ""
	end,
	case wf:q(selected_position) of
		undefined -> "";
		_ -> wf:session(selected_position, wf:q(selected_position)),
			 ""
	end.

get_li_list(RootDir,FileNames)->
	lists:foldl(fun(X, List) -> 
					Elem=case file:read_file_info(filename:join(RootDir,X)) of
							{ok, #file_info{type=directory}} -> 
								"<li class='directory collapsed'><a href='#' rel='"++
									filename:join(RootDir,X)++
									"/'>"++
									X++
									"</a></li>";
							{ok, _} -> 
								R=filename:extension(X),
								Ext=if 
										hd(R) == 46 -> lists:nthtail(1,R);
									    true -> X
									end,
								"<li class='file ext_"++ 
									Ext ++
									"'><a href='#' rel='"++
									filename:join(RootDir,X)++
									"'>"++
									X++
									"</a></li>";
							{error,_}->"<li class='file ext_error'><a href='#' rel='"++
										   filename:join(RootDir,X)++
										   "'>"++
										   X++
										   "</a></li>"
					end,
					Elem ++ List
				end, [], FileNames).